using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;

/*
 * Demo 2
 * 
 * Slightly more sophisticated select statement.
 * Uses parameterized arguments. 
 * Uses column name to refer to columns in reader result.
 */

namespace Demo2
{
	class Program
	{
		static string connectionString = "DRIVER={MySQL ODBC 3.51 Driver};SERVER=oberon.cs.wisc.edu;PORT=3400;DATABASE=cs640_39;USER=cs640_39;PASSWORD=651560;OPTION=3;";

		static void Main(string[] args)
		{
			OdbcConnection connection = new OdbcConnection(connectionString);			
			OdbcCommand command = new OdbcCommand();									
			OdbcDataReader reader = null;												

			command.Connection = connection;											
			command.CommandText = "select lastname,firstname from people where state like ? order by lastname;";
			command.Parameters.AddWithValue("@state", "NJ");

			try
			{
				connection.Open();

				reader = command.ExecuteReader();

				while (reader.Read())
				{
					Console.WriteLine(string.Format("{0}, {1}", reader["lastname"].ToString(), reader["firstname"].ToString()));
				}
			}
			catch (Exception e)
			{
				Console.Error.WriteLine(e.Message);
			}
			finally
			{
				if (reader != null && !reader.IsClosed) 
					reader.Close();
				if (connection.State == ConnectionState.Open) 
					connection.Close();	
			}

			Console.WriteLine("Hit return to exit.");
			Console.Read();
		}
	}
}
